unit house_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls, Buttons, Spin, Math, ExtDlgs;

type
  Thouse_form = class(TForm)
    SGTransf: TStringGrid;
    PCoordinate: TPanel;
    SGCoordinate: TStringGrid;
    PNecessary: TPanel;
    LCoordinate: TLabel;
    PAction: TPanel;
    PBHouse: TPaintBox;
    BStartingData: TButton;
    BSaveToFile: TButton;
    BReadFromFile: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SERib: TSpinEdit;
    SEVertex: TSpinEdit;
    SEAngle: TSpinEdit;
    LRib: TLabel;
    LVertex: TLabel;
    LAngle: TLabel;
    L_P: TLabel;
    L_Px: TLabel;
    E_Py: TEdit;
    L_Py: TLabel;
    E_Px: TEdit;
    Button1: TButton;
    SavePictureDialog1: TSavePictureDialog;
    BBApply: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Label6: TLabel;
    procedure PBHousePaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SGTransfDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure BReadFromFileClick(Sender: TObject);
    procedure BSaveToFileClick(Sender: TObject);
    procedure SGCoordinateDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormResize(Sender: TObject);
    procedure BStartingDataClick(Sender: TObject);
    procedure BBApplyClick(Sender: TObject);
    procedure SGTransfKeyPress(Sender: TObject; var Key: Char);
//    procedure SBRightClick(Sender: TObject);
//    procedure SBLeftClick(Sender: TObject);
    procedure SERibChange(Sender: TObject);
    procedure SEVertexChange(Sender: TObject);
//    procedure SERibClick(Sender: TObject);
//    procedure SEVertexClick(Sender: TObject);
    procedure E_PxClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  house_form: Thouse_form;

type Coordinate=record
        x,y,h:real;
     end;

     PositionData=array[1..17] of Coordinate;
     TransformationMatrix=array[1..3,1..3] of real;
     Confines=record
         B,E:integer;
     end;
     Line=array[1..15] of Confines;

var f:TextFile;
    C,OldC:PositionData;
    T:TransformationMatrix;
    Count,LCount:integer;
    L:Line;
    x_min,x_max,y_min,y_max:real;
    Rib,Vertex:integer;
    Animation:integer;
    B1,B2:integer;
implementation

{$R *.dfm}

procedure ReadFile;
var i,j:integer;
begin
    Readln(f,Count);
    for i:=1 to Count do
        Readln(f,C[i].x,C[i].y);
    Readln(f,LCount);
    for i:=1 to LCount do
        Readln(f,L[i].B,L[i].E);
    for i:=1 to Count do
    begin
        C[i].h:=1;
        OldC[i].h:=1;
    end;
    for i:=1 to 3 do
        for j:=1 to 3 do
            Read(f,T[i,j]);
    for i:=1 to Count do
        Readln(f,OldC[i].x,OldC[i].y);
    with house_form,SGTransf do
    begin
        for i:=1 to 3 do
            for j:=1 to 3 do
                Cells[j-1,i-1]:=FloatToStrF(T[i,j],ffFixed,5,2);
        SEVertex.MaxValue:=Count;
        SERib.MaxValue:=LCount;
        SEAngle.Value:=15;
        SEVertex.Value:=1;
        SERib.Value:=1;
    end;

end;

procedure WriteFile;
var i:integer;
begin
    Writeln(f,Count);
    for i:=1 to Count do
    begin
        Write(f,C[i].x);
        Write(f,' ');
        Writeln(f,C[i].y);
    end;
    Writeln(f,LCount);
    for i:=1 to LCount do
    begin
        Write(f,L[i].B);
        Write(f,' ');
        Writeln(f,L[i].E);
    end;
    for i:=1 to 3 do
    begin
        Write(f,T[i,1]);
        Write(f,' ');
        Write(f,T[i,2]);
        Write(f,' ');
        Writeln(f,T[i,3]);
    end;
    Writeln(f,' ');
    for i:=1 to Count do
    begin
        Write(f,OldC[i].x);
        Write(f,' ');
        Writeln(f,OldC[i].y);
    end;
end;

function Multiplication(C:PositionData):PositionData;
var i:integer;
    NewC:PositionData;
begin
    for i:=1 to Count do
    begin
        NewC[i].x:=C[i].x*T[1,1]+C[i].y*T[2,1]+C[i].h*T[3,1];
        NewC[i].y:=C[i].x*T[1,2]+C[i].y*T[2,2]+C[i].h*T[3,2];
        NewC[i].h:=C[i].x*T[1,3]+C[i].y*T[2,3]+C[i].h*T[3,3];
        NewC[i].x:=NewC[i].x/NewC[i].h;
        NewC[i].y:=NewC[i].y/NewC[i].h;
        NewC[i].h:=1;
    end;
    Result:=NewC;
end;

function MatrixMult(T1,T2:TransformationMatrix):TransformationMatrix;
var Tr:TransformationMatrix;
    i,j,k:integer;
begin
     for i:=1 to 3 do
         for j:=1 to 3 do
         begin
              Tr[i,j]:=0;
              for k:=1 to 3 do
                  Tr[i,j]:=Tr[i,j]+T1[i,k]*T2[k,j]
         end;
     Result:=Tr;
end;

procedure Completion;
var i:integer;
begin   
    with house_form,SGCoordinate do
    begin
        SGCoordinate.RowCount:=Count+1;
        for i:=1 to Count do
        begin
            Cells[0,i]:=IntToStr(i);
            Cells[3,i]:=FloatToStrF(C[i].x,ffFixed,5,1);
            Cells[4,i]:=FloatToStrF(C[i].y,ffFixed,5,1);
            Cells[1,i]:=FloatToStrF(OldC[i].x/OldC[i].h,ffFixed,5,1);
            Cells[2,i]:=FloatToStrF(OldC[i].y/OldC[i].h,ffFixed,5,1);
        end;
    end;
end;

procedure ReadMatrix;
var i,j:integer;
begin
    with house_form,SGTransf do
        for i:=1 to 3 do
            for j:=1 to 3 do
                T[i,j]:=StrToFloatDef(Cells[j-1,i-1],0);
end;

procedure PrintMatrix;
var i,j:integer;
begin
    with house_form,SGTransf do
        for i:=0 to 2 do
            for j:=0 to 2 do
                Cells[j,i]:=FloatToStrF(T[i+1,j+1],ffFixed,5,2);
end;

procedure OldBorder(var OldX_min,OldX_max,OldY_min,OldY_max:real);
var i:integer;
begin
    OldX_min:=C[1].x;
    OldX_max:=OldX_min;
    OldY_min:=C[1].y;
    OldY_max:=OldY_min;

    for i:=1 to Count do
    begin
        if OldX_min>OldC[i].x then OldX_min:=OldC[i].x;
        if OldX_max<OldC[i].x then OldX_max:=OldC[i].x;
        if OldY_min>OldC[i].y then OldY_min:=OldC[i].y;
        if OldY_max<OldC[i].y then OldY_max:=OldC[i].y;
    end;
end;

procedure InitializationT(var T:TransformationMatrix);
var i,j:integer;
begin
    for i:=1 to 3 do
       for j:=1 to 3 do
            if i=j then T[i,j]:=1
           else T[i,j]:=0;
end;

procedure RightRelocation;
begin
    T[3,1]:=T[3,1]+0.4;
    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure LeftRelocation;
begin
    T[3,1]:=T[3,1]-0.4;
    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end; 

procedure TopRelocation;
begin
    T[3,2]:=T[3,2]+0.4;
    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure DownRelocation;
begin
    T[3,2]:=T[3,2]-0.4;
    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure DownShift;
var T1,T2,T3,Transf:TransformationMatrix;
begin
    InitializationT(T1);
    T1[3,2]:=-C[L[1].B].y;

    InitializationT(T2);
    T2[1,2]:=-0.1;

    InitializationT(T3);
    T3[3,2]:=C[L[1].B].y;

    Transf:=MatrixMult(T1,T2);
    Transf:=MatrixMult(Transf,T3);
    T:=MatrixMult(T,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure UpShift;
var T1,T2,T3,Transf:TransformationMatrix;
begin
    InitializationT(T1);
    T1[3,2]:=-C[L[1].B].y;

    InitializationT(T2);
    T2[1,2]:=0.1;

    InitializationT(T3);
    T3[3,2]:=C[L[1].B].y;

    Transf:=MatrixMult(T1,T2);
    Transf:=MatrixMult(Transf,T3);
    T:=MatrixMult(T,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure LeftTurn(Angle:real);
var T1,T2,T3,Transf:TransformationMatrix;
begin
    InitializationT(T1); {   }
    T1[3,1]:=-C[Vertex].x;
    T1[3,2]:=-C[Vertex].y;

    InitializationT(T2); {}
    T2[1,1]:=Cos(Angle);
    T2[2,2]:=Cos(Angle);
    T2[1,2]:=Sin(Angle);
    T2[2,1]:=-Sin(Angle);

    InitializationT(T3); { }
    T3[3,1]:=C[Vertex].x;
    T3[3,2]:=C[Vertex].y;

    Transf:=MatrixMult(T1,T2);
    Transf:=MatrixMult(Transf,T3);
    T:=MatrixMult(T,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure RightTurn(Angle:real);
var T1,T2,T3,Transf:TransformationMatrix;
begin
    InitializationT(T1); {   }
    T1[3,1]:=-C[Vertex].x;
    T1[3,2]:=-C[Vertex].y;

    InitializationT(T2); {}
    T2[1,1]:=Cos(Angle);
    T2[2,2]:=Cos(Angle);
    T2[1,2]:=-Sin(Angle);
    T2[2,1]:=Sin(Angle);

    InitializationT(T3); { }
    T3[3,1]:=+C[Vertex].x;
    T3[3,2]:=+C[Vertex].y;

    Transf:=MatrixMult(T1,T2);
    Transf:=MatrixMult(Transf,T3);
    T:=MatrixMult(T,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure Reflection; {  }
var T1,T2,T3,T4,T5,Transf,OldT:TransformationMatrix;
    Angle:real;
    x,y:real;
    NewC:PositionData;
begin
    OldT:=T;
    Angle:=0;
    InitializationT(T1); {   }
    T1[3,1]:=-C[L[Rib].B].x;
    T1[3,2]:=-C[L[Rib].B].y;

    x:=C[L[Rib].E].x-C[L[Rib].B].x;
    y:=C[L[Rib].E].y-C[L[Rib].B].y;

    InitializationT(T2);
    if x<>0 then
    begin
        Angle:=ArcTan(Abs(y/x));
        if (y/x)>0 then
        begin
            T2[1,1]:=Cos(Angle);
            T2[1,2]:=-Sin(Angle);
            T2[2,1]:=Sin(Angle);
            T2[2,2]:=Cos(Angle);
        end
        else if (y/x)<0 then
             begin
                T2[1,1]:=Cos(Angle);
                T2[1,2]:=Sin(Angle);
                T2[2,1]:=-Sin(Angle);
                T2[2,2]:=Cos(Angle);
             end;
    end;

    Transf:=MatrixMult(T1,T2);
    T:=Transf;
    NewC:=Multiplication(C);
    InitializationT(T3);
    if Round(NewC[L[Rib].E].x)=0 then T3[1,1]:=-1;
    if Round(NewC[L[Rib].E].y)=0 then T3[2,2]:=-1;

    InitializationT(T4);
    if x<>0 then
        if (y/x)<0 then
        begin
            T4[1,1]:=Cos(Angle);
            T4[1,2]:=-Sin(Angle);
            T4[2,1]:=Sin(Angle);
            T4[2,2]:=Cos(Angle);
        end
        else if (y/x)>0 then
             begin
                T4[1,1]:=Cos(Angle);
                T4[1,2]:=Sin(Angle);
                T4[2,1]:=-Sin(Angle);
                T4[2,2]:=Cos(Angle);
             end;

    InitializationT(T5);
    T5[3,1]:=C[L[Rib].B].x;
    T5[3,2]:=C[L[Rib].B].y;

    Transf:=MatrixMult(Transf,T3);
    Transf:=MatrixMult(Transf,T4);
    Transf:=MatrixMult(Transf,T5);
    T:=MatrixMult(OldT,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure SmallScaling;
var T1,T2,T3,T4,T5,Transf:TransformationMatrix;
    x,y:real;
    Angle:real;
begin
    x:=StrToFloatDef(house_form.E_Px.Text,0);
    y:=StrToFloatDef(house_form.E_Py.Text,0);

    InitializationT(T1);
    T1[3,1]:=-C[1].x;
    T1[3,2]:=-C[1].y;

    InitializationT(T2);
    if x<>0 then
    begin
        Angle:=ArcTan(Abs(y/x));
        if (y/x)>0 then
        begin
            T2[1,1]:=Cos(Angle);
            T2[1,2]:=-Sin(Angle);
            T2[2,1]:=Sin(Angle);
            T2[2,2]:=Cos(Angle);
        end
        else if (y/x)<0 then
             begin
                T2[1,1]:=Cos(Angle);
                T2[1,2]:=Sin(Angle);
                T2[2,1]:=-Sin(Angle);
                T2[2,2]:=Cos(Angle);
             end;
    end;

    InitializationT(T3);
    if x<>0 then T3[1,1]:=0.9
    else if y<>0 then T3[2,2]:=0.9;

    InitializationT(T4);
    if x<>0 then
    begin
        Angle:=ArcTan(Abs(y/x));
        if (y/x)<0 then
        begin
            T4[1,1]:=Cos(Angle);
            T4[1,2]:=-Sin(Angle);
            T4[2,1]:=Sin(Angle);
            T4[2,2]:=Cos(Angle);
        end
        else if (y/x)>0 then
             begin
                T4[1,1]:=Cos(Angle);
                T4[1,2]:=Sin(Angle);
                T4[2,1]:=-Sin(Angle);
                T4[2,2]:=Cos(Angle);
             end;
    end;

    InitializationT(T5);
    T5[3,1]:=C[1].x;
    T5[3,2]:=C[1].y;

    Transf:=MatrixMult(T1,T2);
    Transf:=MatrixMult(Transf,T3);
    Transf:=MatrixMult(Transf,T4);
    Transf:=MatrixMult(Transf,T5);
    T:=MatrixMult(T,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

procedure BigScaling;
var T1,T2,T3,T4,T5,Transf:TransformationMatrix;
    x,y:real;
    Angle:real;
begin
    x:=StrToFloatDef(house_form.E_Px.Text,0);
    y:=StrToFloatDef(house_form.E_Py.Text,0);

    InitializationT(T1);
    T1[3,1]:=-C[1].x;
    T1[3,2]:=-C[1].y;

    InitializationT(T2);
    if x<>0 then
    begin
        Angle:=ArcTan(Abs(y/x));
        if (y/x)>0 then
        begin
            T2[1,1]:=Cos(Angle);
            T2[1,2]:=-Sin(Angle);
            T2[2,1]:=Sin(Angle);
            T2[2,2]:=Cos(Angle);
        end
        else if (y/x)<0 then
             begin
                T2[1,1]:=Cos(Angle);
                T2[1,2]:=Sin(Angle);
                T2[2,1]:=-Sin(Angle);
                T2[2,2]:=Cos(Angle);
             end;
    end;

    InitializationT(T3);
    if x<>0 then T3[1,1]:=1.1
    else if y<>0 then T3[2,2]:=1.1;

    InitializationT(T4);
    if x<>0 then
    begin
        Angle:=ArcTan(Abs(y/x));
        if (y/x)<0 then
        begin
            T4[1,1]:=Cos(Angle);
            T4[1,2]:=-Sin(Angle);
            T4[2,1]:=Sin(Angle);
            T4[2,2]:=Cos(Angle);
        end
        else if (y/x)>0 then
             begin
                T4[1,1]:=Cos(Angle);
                T4[1,2]:=Sin(Angle);
                T4[2,1]:=-Sin(Angle);
                T4[2,2]:=Cos(Angle);
             end;
    end;

    InitializationT(T5);
    T5[3,1]:=C[1].x;
    T5[3,2]:=C[1].y;

    Transf:=MatrixMult(T1,T2);
    Transf:=MatrixMult(Transf,T3);
    Transf:=MatrixMult(Transf,T4);
    Transf:=MatrixMult(Transf,T5);
    T:=MatrixMult(T,Transf);

    PrintMatrix;
    C:=Multiplication(OldC);
    Completion;
    house_form.PBHouse.Repaint;
end;

function Scale:real; { .}
var dx,dy,d,kx,ky:real;
    i:integer;
    OldX_min,OldX_max,OldY_min,OldY_max:real;
begin
  x_min:=-25;
  x_max:=25;
  y_min:=-25;
  y_max:=25;
  Result:=7;
end;

procedure Thouse_form.BBApplyClick(Sender: TObject);
begin
    ReadMatrix;
    if T[3,3]<>0 then
    begin
        C:=Multiplication(OldC);
        Completion;
        PBHousePaint(Sender);
    end;
end;

procedure Thouse_form.BReadFromFileClick(Sender: TObject);
begin
    with OpenDialog1 do
        if Execute then
        begin
            AssignFile(f,FileName);
            Reset(f);
            ReadFile;
            CloseFile(f);
        end;
    Completion;
    PBHousePaint(Sender);
end;

procedure Thouse_form.BSaveToFileClick(Sender: TObject);
begin
    with SaveDialog1 do
        if Execute then
        begin
            AssignFile(f,FileName);
            Rewrite(f);
            WriteFile;
            CloseFile(f);
        end;
end;

procedure Thouse_form.BStartingDataClick(Sender: TObject);
begin
    C:=OldC;
    InitializationT(T);
    PrintMatrix;
    Completion;
    PBHousePaint(Sender);
end;

procedure Thouse_form.E_PxClick(Sender: TObject);
begin
    //RGAction.ItemIndex:=1;
end;

procedure Thouse_form.FormCreate(Sender: TObject);
begin
    with SGCoordinate do
    begin
        Cells[1,0]:='OldX';
        Cells[2,0]:='OldY';
        Cells[3,0]:='X';
        Cells[4,0]:='Y';
    end;
    AssignFile(f,'house.txt');
    Reset(f);
    ReadFile;
    Completion;
    CloseFile(f);
    Rib:=SERib.Value;
    Vertex:=SEVertex.Value;

end;

procedure Thouse_form.FormResize(Sender: TObject);
begin
    if ClientHeight<571 then ClientHeight:=571;
    if ClientWidth<719 then ClientWidth:=719;
    BStartingData.Left:=PAction.Width-6-BStartingData.Width;
    BSaveToFile.Left:=PAction.Width-6-BSaveToFile.Width;
    BReadFromFile.Left:=PAction.Width-6-BReadFromFile.Width;
end;

procedure Drawing;
var i:integer;
    Xe,Ye:integer;
begin
    with house_form,PBHouse,Canvas do
    begin
        Pen.Color:=clBlack;
        Pen.Width:=1;

        for i:=1 to LCount do
        begin
            Xe:=Round(Scale*(OldC[L[i].B].x-x_min));
            Ye:=Round(Height-Scale*(OldC[L[i].B].y-y_min));
            MoveTo(Xe,Ye);
            Xe:=Round(Scale*(OldC[L[i].E].x-x_min));
            Ye:=Round(Height-Scale*(OldC[L[i].E].y-y_min));
            LineTo(Xe,Ye);
        end;

        Pen.Color:=clNavy;
        Pen.Width:=2;

        for i:=1 to LCount do
        begin
            Xe:=Round(Scale*(C[L[i].B].x-x_min));
            Ye:=Round(Height-Scale*(C[L[i].B].y-y_min));
            MoveTo(Xe,Ye);
            Xe:=Round(Scale*(C[L[i].E].x-x_min));
            Ye:=Round(Height-Scale*(C[L[i].E].y-y_min));
            LineTo(Xe,Ye);
        end;

        Pen.Color:=clRed; { }
        Xe:=Round(Scale*(C[L[Rib].B].x-x_min));
        Ye:=Round(Height-Scale*(C[L[Rib].B].y-y_min));
        MoveTo(Xe,Ye);
        Xe:=Round(Scale*(C[L[Rib].E].x-x_min));
        Ye:=Round(Height-Scale*(C[L[Rib].E].y-y_min));
        LineTo(Xe,Ye);

        Pen.Color:=clGreen;
        Ellipse(Round(Scale*(C[Vertex].x-x_min))-3,
                      Round(Height-Scale*(C[Vertex].y-y_min))-3,
                      Round(Scale*(C[Vertex].x-x_min))+3,
                      Round(Height-Scale*(C[Vertex].y-y_min))+3);

    end;
end;

procedure DatumLine;
var Xc,Yc:integer;
begin
    Scale;
    with house_form.PBHouse,Canvas do
    begin
        Xc:=Round(Abs(x_min)*Scale);
        Yc:=Round(Abs(y_min)*Scale);
        Pen.Width:=1;
        Pen.Color:=clBtnShadow;
        Brush.Color:=clWhite;
        Rectangle(0,0,Width,Height);
        Pen.Color:=clGray;
        MoveTo(0,Height-Yc);
        LineTo(Width,Height-Yc);
        LineTo(Width-10,Height-Yc-4);
        MoveTo(Width,Height-Yc);
        LineTo(Width-10,Height-Yc+4);
        MoveTo(Xc,Height);
        LineTo(Xc,0);
        LineTo(Xc-4,10);
        MoveTo(Xc,0);
        LineTo(Xc+4,10);
    end;
end;

procedure Thouse_form.PBHousePaint(Sender: TObject);
begin
    DatumLine;
    Drawing;
end;

{procedure Thouse_form.SBLeftClick(Sender: TObject);
var Angle:real;
begin
    Angle:=DegToRad(SEAngle.Value);
    case RGAction.ItemIndex of
        0: LeftRelocation;
        1: SmallScaling;
        2: DownShift;
        3: Reflection;
        4: LeftTurn(Angle);
    end;
    Animation:=1;
end;}

{procedure Thouse_form.SBRightClick(Sender: TObject);
var Angle:real;
begin
    Angle:=DegToRad(SEAngle.Value);
    case RGAction.ItemIndex of
        0: RightRelocation;
        1: BigScaling;
        2: UpShift;
        3: Reflection;
        4: RightTurn(Angle);
    end;
    Animation:=2;
end;}

procedure Thouse_form.SERibChange(Sender: TObject);
begin
    Rib:=SERib.Value;
    PBHousePaint(Sender);
end;

{procedure Thouse_form.SERibClick(Sender: TObject);
begin
    RGAction.ItemIndex:=3;
end;}

procedure Thouse_form.SEVertexChange(Sender: TObject);
begin
    Vertex:=SEVertex.Value;
    PBHousePaint(Sender);
end;

{procedure Thouse_form.SEVertexClick(Sender: TObject);
begin
    RGAction.ItemIndex:=4;
end;}

procedure Thouse_form.SGCoordinateDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var st:string;
begin
    with SGCoordinate,Canvas,Rect do
    begin
        st:=Cells[ACol, ARow];
        if (ACol<>0) and (ARow<>0) then Font.Style:=[fsItalic]
        else Font.Style:=[fsItalic,fsBold];
        if (ACol=3) or (ACol=4) then Font.Color:=clNavy
        else Font.Color:=clWindowText;

        FillRect(Rect);
        TextOut(Left+(Right-Left-TextWidth(st)) div 2,
                      Top+(Bottom-Top-TextHeight(st)) div 2,st);
    end;
end;

procedure Thouse_form.SGTransfDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var st:string;
begin
    with SGTransf,Canvas,Rect do
    begin
        st:=Cells[Acol, Arow];
        FillRect(Rect);
        TextOut(Left+(Right-Left-TextWidth(st)) div 2,
                      Top+(Bottom-Top-TextHeight(st)) div 2,st);
    end;

end;

procedure Thouse_form.SGTransfKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in ['0'..'9',#8,'-',',',#13]) then
    begin
        Key:=#0;
        Beep();
    end;
end;

procedure Thouse_form.Button1Click(Sender: TObject);
var B:TBitMap;
begin
    B:=TBitmap.Create;
    B.Width:=house_form.ClientWidth;
    B.Height:=house_form.ClientHeight;
    with house_form,Canvas do
        B.Canvas.CopyRect(Rect(0,0,Width,Height),Canvas,
                        Rect(0,0,Width,Height));
    with SavePictureDialog1 do
    if Execute then
    begin
        B.SaveToFile(FileName);
        B.Free;
    end;
end;

procedure Thouse_form.Button7Click(Sender: TObject);
begin
    RightRelocation;
    Animation:=2;
    B2:=7;
end;

procedure Thouse_form.Button8Click(Sender: TObject);
begin
    BigScaling;
    Animation:=2;
    B2:=8;
end;

procedure Thouse_form.Button9Click(Sender: TObject);
begin
    UpShift;
    Animation:=2;
    B2:=9;
end;

procedure Thouse_form.Button10Click(Sender: TObject);
begin
     Reflection;
     Animation:=2;
     B2:=10;
end;

procedure Thouse_form.Button11Click(Sender: TObject);
var Angle:real;
begin
    Angle:=DegToRad(SEAngle.Value);
    RightTurn(Angle);
    Animation:=2;
    B2:=11;
end;

procedure Thouse_form.Button2Click(Sender: TObject);
begin
LeftRelocation;
 Animation:=1;B1:=2;
end;

procedure Thouse_form.Button3Click(Sender: TObject);
begin
SmallScaling;
Animation:=1;B1:=3;
end;

procedure Thouse_form.Button4Click(Sender: TObject);
begin
DownShift;
Animation:=1;B1:=4;
end;

procedure Thouse_form.Button5Click(Sender: TObject);
begin
Reflection;
Animation:=1;B1:=5;
end;

procedure Thouse_form.Button6Click(Sender: TObject);
var Angle:real;
begin
Angle:=DegToRad(SEAngle.Value);
LeftTurn(Angle);
Animation:=1; B1:=6;
end;

procedure Thouse_form.Button12Click(Sender: TObject);
begin
    TopRelocation;
    Animation:=2;
    B2:=7;
end;

procedure Thouse_form.Button13Click(Sender: TObject);
begin
DownRelocation;
 Animation:=1;B1:=2;
end;



end.
